package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.StoreCollection;
import com.izouma.awesomeadmin.service.StoreCollectionService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/storeCollection")
@RequiresAuthentication
public class StoreCollectionController {

    @Autowired
    private StoreCollectionService storeCollectionService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(StoreCollection record) {
        List<StoreCollection> pp = storeCollectionService.getStoreCollectionList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getStoreCollection", method = RequestMethod.GET)
    @ResponseBody
    public Result getStoreCollection(@RequestParam(required = false, value = "id") String id) {
        StoreCollection data = storeCollectionService.getStoreCollectionById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(StoreCollection record) {
        StoreCollection data = storeCollectionService.getStoreCollection(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, StoreCollection record) {
        Map<String, Object> result = new HashMap<>();

        List<StoreCollection> pp =storeCollectionService.getStoreCollectionByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(StoreCollection record) {
        boolean num = storeCollectionService.createStoreCollection(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateStoreCollection(StoreCollection record) {
        boolean num = storeCollectionService.updateStoreCollection(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteStoreCollection(@RequestParam(required = true, value = "id") String id) {

        boolean num = storeCollectionService.deleteStoreCollection(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, StoreCollection record) throws Exception {

    List<StoreCollection> storeCollections = storeCollectionService.getStoreCollectionList(record);


        String sheetName = "store_collection";
        String titleName = "店铺收藏数据表";
        String fileName = "店铺收藏表";
        int columnNumber = 9;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "类型" ,   "用户" ,   "店铺"  };
        String[][] dataList = new String[storeCollections.size()][9];

        for (int i = 0; i < storeCollections.size(); i++) {

                        dataList[i][0] = String.valueOf(storeCollections.get(i).getId());
                        dataList[i][1] = String.valueOf(storeCollections.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(storeCollections.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(storeCollections.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(storeCollections.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(storeCollections.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(storeCollections.get(i).getTypeFlag());
                        dataList[i][7] = String.valueOf(storeCollections.get(i).getUserId());
                        dataList[i][8] = String.valueOf(storeCollections.get(i).getTargetId());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

